<?php

namespace FiloBlu\Newsletter\Controller\Plugin\Subscriber;

use Magento\Store\Model\StoreManagerInterface;

class Confirm {

    protected $_storeManager;
    protected $_helper;
    protected $_modelThankYou;

    /**
     * Subscriber factory
     *
     * @var SubscriberFactory
     */
    protected $_subscriberFactory;

    public function __construct(\FiloBlu\Newsletter\Helper\Data $helper, StoreManagerInterface $storeManager, \FiloBlu\Newsletter\Model\ThankYou $modelThankYou, \Magento\Newsletter\Model\SubscriberFactory $subscriberFactory
    ) {
      
        $this->_helper = $helper;
        $this->_modelThankYou = $modelThankYou;
        $this->_storeManager = $storeManager;
        $this->_subscriberFactory = $subscriberFactory;
    }

    public function afterExecute(\Magento\Newsletter\Controller\Subscriber\Confirm $subject, $result) {
  
        if ($this->_helper->getConfig("general/enabled") && $subject->getRequest()->getParam('thankyou_id') && $subject->getRequest()->getParam('thankyou_id') != 0) {

            $id = (int) $subject->getRequest()->getParam('id');
            $code = (string) $subject->getRequest()->getParam('code');

            if ($id && $code) {
                /** @var \Magento\Newsletter\Model\Subscriber $subscriber */
                $subscriber = $this->_subscriberFactory->create()->load($id);

                if ($subscriber->getId() && $subscriber->getCode()) {
                    if ($subscriber->getStatus() == \Magento\Newsletter\Model\Subscriber::STATUS_SUBSCRIBED) {

                        $this->_helper->setThankYouCookie($subject->getRequest()->getParam('thankyou_id'));
                        $url = $this->_storeManager->getStore()->getBaseUrl() . $this->_modelThankYou->getUrlThankYouPageById($subject->getRequest()->getParam('thankyou_id'))->getData()["url_key"] . ($subject->getRequest()->getParams() ? "?" . http_build_query($subject->getRequest()->getParams()) : "");
                        $subject->getResponse()->setRedirect($url)->sendResponse();
                    } else {
//                    $this->messageManager->addError(__('This is an invalid subscription confirmation code.'));
                    }
                } else {
//                $this->messageManager->addError(__('This is an invalid subscription ID.'));
                }
            }
        }
    }

}
